<?php
    if(!defined("__ZBXE__")) exit();

    /**
     * @file daumview_vote.addon.php
     * @author k2man (k2mani@gmail.com)
     * @brief 다음view 추가 애드온
     **/

	if($called_position == 'before_display_content' && Context::getResponseMethod() == 'HTML') {

		if ($addon_info->type == 2) {
			$type = 2; $width = 400; $height = 58;
		} elseif ($addon_info->type == 3) {
			$type = 3; $width = 67; $height = 80;
		} else {
			$type = 1; $width = 400; $height = 80;
		}

		preg_match_all("/document_(.*)_[0-9] xe_content/", $output, $match);

		for ($index = 0; $index < sizeof($match[1]); $index++) {

			$document_srl = $match[1][$index];
	
			if (!$document_srl) return;

			$db_info = Context::getDBInfo();
			$default_url = $db_info->default_url;
			if (substr($default_url, -1) == '/')
				$default_url = substr($default_url, 0, strlen($default_url)-1);
			if (substr($default_url, 0, 7) != 'http://')
				$default_url = 'http://' . $default_url;
				
			if ($db_info->use_rewrite == 'Y')
				$url = 'http://api.view.daum.net/open/news_info.xml?permalink='.$default_url.'/'.$document_srl;
			else
				$url = 'http://api.view.daum.net/open/news_info.xml?permalink=http://'.$default_url.'/?document_srl='.$document_srl;

			$buff = FileHandler::getRemoteResource($url);
			$oXmlParser = new XmlParser();
			$xml_doc = $oXmlParser->parse($buff);

			// 다음View에 등록되어 있다면, 추천 버튼 출력
			if ($xml_doc->result->head->code->body == '200') {

				$embed = '<div style="text-align:center; width:100%; margin:10px;"><embed src="http://api.v.daum.net/static/recombox'.$type.'.swf?nid='.$xml_doc->result->entity->news->id->body.'" quality="high" bgcolor="#ffffff" width="'.$width.'" height="'.$height.'" type="application/x-shockwave-flash"></embed></div>';
				$output = str_replace('<!--AfterDocument('.$document_srl, $embed.'<!--AfterDocument('.$document_srl, $output);

			// 등록되지 않았다면, 전송기능 출력
			} else {

				$logged_info = Context::get('logged_info');
				if ($logged_info->is_admin !='Y' && $logged_info->is_site_admin != 'Y') return;

				Context::addJsFile('./addons/daumview_vote/daumview_vote.js');

				$buff = FileHandler::getRemoteResource('http://api.view.daum.net/open/user_info.xml?blogurl='.$default_url);
				$oXmlParser = new XmlParser();
				$xml_doc = $oXmlParser->parse($buff);

				$embed = '<div style="float:right;"><a href="javascript:"><img src="./addons/daumview_vote/send.gif" border="0" id="daumview_send_button"></a></div>';
				$embed .= '<div style="width:100%; padding:10px; text-align:center; display:none; background:#f5f5f5;" id="daumview_send_view">';

				// 다음View에 가입되어 있으면 카테고리 출력
				if ($xml_doc->result->head->code->body == '200') {

					$buff = FileHandler::getRemoteResource('http://api.view.daum.net/open/category.xml');
					$oXmlParser = new XmlParser();
					$xml_doc = $oXmlParser->parse($buff);

					if ($xml_doc->result->head->code->body == '200') {				
						$embed .= '<table border=0 width=97% cellpadding=3>';
						for ($entity = 0; $entity < sizeof($xml_doc->result->entity->category); $entity++) {
							$embed .= '<tr><td><b>' . $xml_doc->result->entity->category[$entity]->name->body . '</b></td><td align="left">';

							for ($list = 0; $list < sizeof($xml_doc->result->entity->category[$entity]->list->category); $list++) {
								if (sizeof($xml_doc->result->entity->category[$entity]->list->category) > 1)
									$embed .= '&nbsp;<input type="radio" name="daumview_trackback" id="daumview_trackback" value="' . $xml_doc->result->entity->category[$entity]->list->category[$list]->trackback_url->body . '">&nbsp;' . $xml_doc->result->entity->category[$entity]->list->category[$list]->name->body . '&nbsp;';
								else
									$embed .= '&nbsp;<input type="radio" name="daumview_trackback" id="daumview_trackback" value="' . $xml_doc->result->entity->category[$entity]->list->category->trackback_url->body . '">&nbsp;' . $xml_doc->result->entity->category[$entity]->list->category->name->body . '&nbsp;';

								if ($list == 7)
									$embed .= '<br />';
							}

							$embed .= '</td></tr>';
						}
						$embed .= '<tr><td colspan="2" align="right" id="daumview_result"><a href="javascript:"><img src="./addons/daumview_vote/send_action.gif" border="0" id="daumview_send_action"></a></td></tr>';
						$embed .= '</table>';

						$oDocumentModel = &getModel('document');
						$oDocument = $oDocumentModel->getDocument($document_srl);

						$embed .= '<input type="hidden" id="daumview_default_url" value="' . $default_url . '">';
						$embed .= '<input type="hidden" id="daumview_title" value="' . urlencode($oDocument->getTitleText()) . '">';
						$embed .= '<input type="hidden" id="daumview_excerpt" value="' . urlencode($oDocument->getSummary(200)) . '">';
						$embed .= '<input type="hidden" id="daumview_document_srl" value="' . $document_srl . '">';
						
					}

				} else {
					$embed .= '다음View에 가입되지 않았습니다. <a href="http://v.daum.net" target="_blank">http://v.daum.net</a>에서 가입 후 사용하실 수 있습니다.';
				}

				$embed .= '</div>';
				$output = str_replace('<!--AfterDocument('.$document_srl, $embed.'<!--AfterDocument('.$document_srl, $output);

			}
		}
	}

?>
